'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.matchPattern = matchPattern;

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// FIXME: platform
function matchPattern(pattern, text) {
  if (typeof pattern === 'string') {
    return pattern === text;
  } else if (pattern instanceof RegExp) {
    return pattern.test(text);
  }
  return false;
}

var HandlerBuilder = function () {
  function HandlerBuilder() {
    (0, _classCallCheck3.default)(this, HandlerBuilder);
    this._beforeHandlers = [];
    this._handlers = [];
    this._errorHandler = null;
  }

  (0, _createClass3.default)(HandlerBuilder, [{
    key: 'before',
    value: function before(handler) {
      (0, _warning2.default)(false, '`before` is deprecated. Use middleware instead.');

      this._beforeHandlers.push(handler);
      return this;
    }
  }, {
    key: 'beforeMessage',
    value: function beforeMessage(handler) {
      (0, _warning2.default)(false, '`beforeMessage` is deprecated. Use middleware instead.');

      this._beforeHandlers.push(function (context) {
        if (context.event.isMessage) {
          return handler(context);
        }
      });
      return this;
    }
  }, {
    key: 'on',
    value: function on(predicate, handler) {
      this._handlers.push({
        predicate: predicate,
        handler: handler
      });
      return this;
    }
  }, {
    key: 'onEvent',
    value: function onEvent(handler) {
      this._handlers.push({
        predicate: function predicate() {
          return true;
        },
        handler: handler
      });
      return this;
    }
  }, {
    key: 'onError',
    value: function onError(handler) {
      this._errorHandler = handler;
      return this;
    }
  }, {
    key: 'build',
    value: function build() {
      var _this = this;

      var handlers = this._handlers;

      return function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(context) {
          var i, _i, _handlers$_i, _predicate, _handler, predicateReturn;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  i = 0;

                case 2:
                  if (!(i < _this._beforeHandlers.length)) {
                    _context.next = 8;
                    break;
                  }

                  _context.next = 5;
                  return _this._beforeHandlers[i](context);

                case 5:
                  i++;
                  _context.next = 2;
                  break;

                case 8:
                  _i = 0;

                case 9:
                  if (!(_i < handlers.length)) {
                    _context.next = 21;
                    break;
                  }

                  _handlers$_i = handlers[_i], _predicate = _handlers$_i.predicate, _handler = _handlers$_i.handler;
                  // eslint-disable-next-line no-await-in-loop

                  _context.next = 13;
                  return _predicate(context);

                case 13:
                  predicateReturn = _context.sent;

                  if (!(typeof predicateReturn === 'boolean' && predicateReturn)) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 17;
                  return _handler(context);

                case 17:
                  return _context.abrupt('break', 21);

                case 18:
                  _i++;
                  _context.next = 9;
                  break;

                case 21:
                  _context.next = 28;
                  break;

                case 23:
                  _context.prev = 23;
                  _context.t0 = _context['catch'](0);

                  if (!_this._errorHandler) {
                    _context.next = 27;
                    break;
                  }

                  return _context.abrupt('return', _this._errorHandler(context, _context.t0));

                case 27:
                  throw _context.t0;

                case 28:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this, [[0, 23]]);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }();
    }
  }]);
  return HandlerBuilder;
}();

exports.default = HandlerBuilder;