"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClassifierHandlerBuilder = function () {
  function ClassifierHandlerBuilder(classifier, threshold) {
    (0, _classCallCheck3.default)(this, ClassifierHandlerBuilder);

    this._classifier = classifier;
    this._threshold = threshold;
    this._intentHandlers = [];
    this._unmatchedHandler = null;
  }

  (0, _createClass3.default)(ClassifierHandlerBuilder, [{
    key: "onIntent",
    value: function onIntent(intent, handler) {
      this._intentHandlers.push({
        intent: intent,
        handler: handler
      });
      return this;
    }
  }, {
    key: "onUnmatched",
    value: function onUnmatched(handler) {
      this._unmatchedHandler = handler;
      return this;
    }
  }, {
    key: "build",
    value: function build() {
      var _this = this;

      return function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(context) {
          var result, intent, intentHandler;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!context.event.isTextMessage) {
                    _context.next = 15;
                    break;
                  }

                  _context.next = 3;
                  return _this._classifier.predict(context.event.message.text);

                case 3:
                  result = _context.sent;
                  intent = result.intents.sort(function (a, b) {
                    if (a.score > b.score) return -1;
                    if (a.score < b.score) return 1;
                    return 0;
                  })[0];

                  if (!(intent.score > _this._threshold)) {
                    _context.next = 12;
                    break;
                  }

                  intentHandler = _this._findMatchIntentHandler(intent.name);

                  if (!intentHandler) {
                    _context.next = 10;
                    break;
                  }

                  _context.next = 10;
                  return intentHandler.handler(context, result);

                case 10:
                  _context.next = 15;
                  break;

                case 12:
                  if (!_this._unmatchedHandler) {
                    _context.next = 15;
                    break;
                  }

                  _context.next = 15;
                  return _this._unmatchedHandler(context, result);

                case 15:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, _this);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }();
    }
  }, {
    key: "_findMatchIntentHandler",
    value: function _findMatchIntentHandler(intent) {
      return this._intentHandlers.find(function (intentHandler) {
        return intentHandler.intent === intent;
      });
    }
  }]);
  return ClassifierHandlerBuilder;
}();

exports.default = ClassifierHandlerBuilder;