'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _BasicHandlerBuilder2 = require('./BasicHandlerBuilder');

var _BasicHandlerBuilder3 = _interopRequireDefault(_BasicHandlerBuilder2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LINEHandlerBuilder = function (_BasicHandlerBuilder) {
  (0, _inherits3.default)(LINEHandlerBuilder, _BasicHandlerBuilder);

  function LINEHandlerBuilder() {
    (0, _classCallCheck3.default)(this, LINEHandlerBuilder);
    return (0, _possibleConstructorReturn3.default)(this, (LINEHandlerBuilder.__proto__ || Object.getPrototypeOf(LINEHandlerBuilder)).apply(this, arguments));
  }

  (0, _createClass3.default)(LINEHandlerBuilder, [{
    key: 'onMessage',
    value: function onMessage(predicate, handler) {
      this.on(function (context) {
        return context.event.isMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onText',
    value: function onText(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onText\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.onMessage(function (context) {
          return context.event.isTextMessage && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.message.text);
        }, handler);
      } else {
        handler = arg1;

        this.onMessage(function (context) {
          return context.event.isTextMessage;
        }, handler);
      }

      return this;
    }
  }, {
    key: 'onPostback',
    value: function onPostback(predicate, handler) {
      this.on(function (context) {
        return context.event.isPostback && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onPayload',
    value: function onPayload(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onPayload\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.on(function (context) {
          return context.event.isPostback && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.postback.data);
        }, handler);
      } else {
        handler = arg1;

        this.on(function (context) {
          return context.event.isPostback;
        }, handler);
      }

      return this;
    }

    // account is added as a friend (or unblocked).

  }, {
    key: 'onFollow',
    value: function onFollow(handler) {
      this.on(function (context) {
        return context.event.isFollow;
      }, handler);
      return this;
    }
  }, {
    key: 'onUnfollow',
    value: function onUnfollow(handler) {
      this.on(function (context) {
        return context.event.isUnfollow;
      }, handler);
      return this;
    }

    // account joins a group or talk room.

  }, {
    key: 'onJoin',
    value: function onJoin(handler) {
      this.on(function (context) {
        return context.event.isJoin;
      }, handler);
      return this;
    }

    // account leaves a group.

  }, {
    key: 'onLeave',
    value: function onLeave(handler) {
      this.on(function (context) {
        return context.event.isLeave;
      }, handler);
      return this;
    }
  }, {
    key: 'onBeacon',
    value: function onBeacon(predicate, handler) {
      this.on(function (context) {
        return context.event.isBeacon && predicate(context);
      }, handler);
      return this;
    }
  }]);
  return LINEHandlerBuilder;
}(_BasicHandlerBuilder3.default);

exports.default = LINEHandlerBuilder;