'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _messagingApiMessenger = require('messaging-api-messenger');

var _MessengerContext = require('../context/MessengerContext');

var _MessengerContext2 = _interopRequireDefault(_MessengerContext);

var _MessengerEvent = require('../context/MessengerEvent');

var _MessengerEvent2 = _interopRequireDefault(_MessengerEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MessengerConnector = function () {
  function MessengerConnector(_ref) {
    var accessToken = _ref.accessToken;
    (0, _classCallCheck3.default)(this, MessengerConnector);

    this._client = _messagingApiMessenger.MessengerClient.connect(accessToken);
  }

  (0, _createClass3.default)(MessengerConnector, [{
    key: '_getRawEventsFromRequest',
    value: function _getRawEventsFromRequest(body) {
      if (body.entry) {
        var _entry = body.entry;

        return _entry.map(function (ent) {
          if (ent.messaging) {
            return ent.messaging[0];
          }

          if (ent.standby) {
            return ent.standby[0];
          }
          // $FlowExpectedError
          return null;
        }).filter(function (event) {
          return event != null;
        });
      }

      return [body];
    }
  }, {
    key: '_isStandby',
    value: function _isStandby(body) {
      if (!body.entry) return false;
      var entry = body.entry[0];

      return !!entry.standby;
    }
  }, {
    key: 'getUniqueSessionIdFromRequest',
    value: function getUniqueSessionIdFromRequest(body) {
      var rawEvent = this._getRawEventsFromRequest(body)[0];
      if (rawEvent.message && rawEvent.message.is_echo && rawEvent.recipient) {
        return rawEvent.recipient.id;
      }
      if (rawEvent.sender) {
        return rawEvent.sender.id;
      }
      return null;
    }
  }, {
    key: 'updateSession',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(session, body) {
        var senderId, user;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (session.user) {
                  _context.next = 6;
                  break;
                }

                senderId = this.getUniqueSessionIdFromRequest(body);
                _context.next = 4;
                return this._client.getUserProfile(senderId);

              case 4:
                user = _context.sent;


                session.user = (0, _extends3.default)({
                  platform: 'messenger'
                }, user, {
                  id: senderId
                });

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateSession(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return updateSession;
    }()
  }, {
    key: 'mapRequestToEvents',
    value: function mapRequestToEvents(body) {
      var rawEvents = this._getRawEventsFromRequest(body);
      var isStandby = this._isStandby(body);
      return rawEvents.map(function (event) {
        return new _MessengerEvent2.default(event, { isStandby: isStandby });
      });
    }
  }, {
    key: 'createContext',
    value: function createContext(_ref3) {
      var event = _ref3.event,
          session = _ref3.session;

      return new _MessengerContext2.default({
        client: this._client,
        event: event,
        session: session
      });
    }
  }, {
    key: 'platform',
    get: function get() {
      return 'messenger';
    }
  }, {
    key: 'client',
    get: function get() {
      return this._client;
    }
  }]);
  return MessengerConnector;
}(); /*
       eslint-disable class-methods-use-this
       
     */


exports.default = MessengerConnector;