'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _constants = require('../constants');

var constants = _interopRequireWildcard(_constants);

var _BasicHandlerBuilder2 = require('./BasicHandlerBuilder');

var _BasicHandlerBuilder3 = _interopRequireDefault(_BasicHandlerBuilder2);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MessengerHandlerBuilder = function (_BasicHandlerBuilder) {
  (0, _inherits3.default)(MessengerHandlerBuilder, _BasicHandlerBuilder);

  function MessengerHandlerBuilder() {
    (0, _classCallCheck3.default)(this, MessengerHandlerBuilder);
    return (0, _possibleConstructorReturn3.default)(this, (MessengerHandlerBuilder.__proto__ || Object.getPrototypeOf(MessengerHandlerBuilder)).apply(this, arguments));
  }

  (0, _createClass3.default)(MessengerHandlerBuilder, [{
    key: 'onMessage',
    value: function onMessage(predicate, handler) {
      this.on(function (context) {
        return context.event.isMessage && !context.event.isEcho && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onText',
    value: function onText(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onText\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.onMessage(function (context) {
          return context.event.isTextMessage && !context.event.isEcho && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.message.text);
        }, handler);
      } else {
        handler = arg1;

        this.onMessage(function (context) {
          return context.event.isTextMessage && !context.event.isEcho;
        }, handler);
      }

      return this;
    }
  }, {
    key: 'onPostback',
    value: function onPostback(predicate, handler) {
      this.on(function (context) {
        return context.event.isPostback && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onPayload',
    value: function onPayload(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onPayload\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.on(function (_ref) {
          var event = _ref.event;

          if (event.isPostback && (0, _BasicHandlerBuilder2.matchPattern)(pattern, event.postback.payload)) {
            return true;
          } else if (event.isMessage && event.message.quick_reply && (0, _BasicHandlerBuilder2.matchPattern)(pattern, event.message.quick_reply.payload)) {
            return true;
          }
          return false;
        }, handler);
      } else {
        handler = arg1;

        this.on(function (_ref2) {
          var event = _ref2.event;
          return event.isPostback || event.isMessage && !!event.message.quick_reply;
        }, handler);
      }
      return this;
    }
  }, {
    key: 'onPayment',
    value: function onPayment(predicate, handler) {
      this.on(function (context) {
        return context.event.isPayment && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onGetStarted',
    value: function onGetStarted(handler) {
      this.onPayload(constants.payload.GET_STARTED, handler);
      return this;
    }
  }, {
    key: 'onQuickReply',
    value: function onQuickReply(predicate, handler) {
      this.onMessage(function (context) {
        return !!context.event.message.quick_reply && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onEcho',
    value: function onEcho(predicate, handler) {
      this.on(function (context) {
        return context.event.isEcho && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onEchoText',
    value: function onEchoText(pattern, handler) {
      this.on(function (context) {
        return context.event.isEcho && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.message.text);
      }, // FIXME
      handler);
      return this;
    }
  }, {
    key: 'onRead',
    value: function onRead(predicate, handler) {
      this.on(function (context) {
        return context.event.isRead && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onDelivery',
    value: function onDelivery(predicate, handler) {
      this.on(function (context) {
        return context.event.isDelivery && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onLocation',
    value: function onLocation(predicate, handler) {
      this.on(function (context) {
        return context.event.isLocationMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onImage',
    value: function onImage(predicate, handler) {
      this.on(function (context) {
        return context.event.isImageMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onAudio',
    value: function onAudio(predicate, handler) {
      this.on(function (context) {
        return context.event.isAudioMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onVideo',
    value: function onVideo(predicate, handler) {
      this.on(function (context) {
        return context.event.isVideoMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onFile',
    value: function onFile(predicate, handler) {
      this.on(function (context) {
        return context.event.isFileMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onFallback',
    value: function onFallback(predicate, handler) {
      this.on(function (context) {
        return context.event.isFallbackMessage && predicate(context);
      }, handler);
      return this;
    }

    // FIXME

  }, {
    key: 'onEvent',
    value: function onEvent(handler) {
      this._handlers.push({
        predicate: function predicate(context) {
          return !context.event.isEcho && !context.event.isRead && !context.event.isDelivery;
        },
        handler: handler
      });
      return this;
    }
  }]);
  return MessengerHandlerBuilder;
}(_BasicHandlerBuilder3.default);

exports.default = MessengerHandlerBuilder;