'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _messagingApiSlack = require('messaging-api-slack');

var _SlackContext = require('../context/SlackContext');

var _SlackContext2 = _interopRequireDefault(_SlackContext);

var _SlackEvent = require('../context/SlackEvent');

var _SlackEvent2 = _interopRequireDefault(_SlackEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// FIXME
var SlackConnector = function () {
  function SlackConnector(_ref) {
    var token = _ref.accessToken;
    (0, _classCallCheck3.default)(this, SlackConnector);

    this._client = _messagingApiSlack.SlackOAuthClient.connect(token);
  }

  (0, _createClass3.default)(SlackConnector, [{
    key: '_getRawEventFromRequest',
    value: function _getRawEventFromRequest(body) {
      return body.event;
    }
  }, {
    key: 'getUniqueSessionIdFromRequest',
    value: function getUniqueSessionIdFromRequest(body) {
      if (body.event.channel && typeof body.event.channel === 'string') {
        return body.event.channel;
      }
      return 'U000000000'; // FIXME
    }
  }, {
    key: 'updateSession',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(session, body) {
        var channelId, senderId, sender, channel, allUsers;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!((0, _typeof3.default)(session.user) === 'object' && session.user && session.user.id && session.user.id === body.event.user)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return');

              case 2:
                channelId = this.getUniqueSessionIdFromRequest(body);
                senderId = body.event.user;
                _context.next = 6;
                return this._client.getUserInfo(senderId);

              case 6:
                sender = _context.sent;

                session.user = (0, _extends3.default)({
                  id: senderId,
                  platform: 'slack'
                }, sender);

                // TODO: check join or leave events?

                if (!(!session.channel || session.channel.members && Array.isArray(session.channel.members) && session.channel.members.indexOf(senderId) < 0)) {
                  _context.next = 13;
                  break;
                }

                _context.next = 11;
                return this._client.getChannelInfo(channelId);

              case 11:
                channel = _context.sent;

                session.channel = channel;

              case 13:
                if (!(!session.team || session.team.members && Array.isArray(session.team.members) && session.team.members.indexOf(senderId) < 0)) {
                  _context.next = 18;
                  break;
                }

                _context.next = 16;
                return this._client.getAllUserList();

              case 16:
                allUsers = _context.sent;

                session.team = {
                  members: allUsers
                };

              case 18:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateSession(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return updateSession;
    }()
  }, {
    key: 'mapRequestToEvents',
    value: function mapRequestToEvents(body) {
      var rawEvent = this._getRawEventFromRequest(body);

      if (rawEvent.bot_id || rawEvent.subtype === 'bot_message') {
        return []; // FIXME
      }

      return [new _SlackEvent2.default(rawEvent)];
    }
  }, {
    key: 'createContext',
    value: function createContext(_ref3) {
      var event = _ref3.event,
          session = _ref3.session;

      return new _SlackContext2.default({
        client: this._client,
        event: event,
        session: session
      });
    }
  }, {
    key: 'platform',
    get: function get() {
      return 'slack';
    }
  }, {
    key: 'client',
    get: function get() {
      return this._client;
    }
  }]);
  return SlackConnector;
}(); /*
       eslint-disable class-methods-use-this
       
     */


exports.default = SlackConnector;