'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _messagingApiTelegram = require('messaging-api-telegram');

var _TelegramContext = require('../context/TelegramContext');

var _TelegramContext2 = _interopRequireDefault(_TelegramContext);

var _TelegramEvent = require('../context/TelegramEvent');

var _TelegramEvent2 = _interopRequireDefault(_TelegramEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TelegramConnector = function () {
  function TelegramConnector(_ref) {
    var accessToken = _ref.accessToken;
    (0, _classCallCheck3.default)(this, TelegramConnector);

    this._client = _messagingApiTelegram.TelegramClient.connect(accessToken);
  }

  (0, _createClass3.default)(TelegramConnector, [{
    key: '_getRawEventFromRequest',
    value: function _getRawEventFromRequest(body) {
      return body;
    }
  }, {
    key: 'getUniqueSessionIdFromRequest',
    value: function getUniqueSessionIdFromRequest(body) {
      var id = '';

      if (body.message !== undefined) {
        id = body.message.from.id;
      } else if (body.callback_query !== undefined) {
        id = body.callback_query.from.id;
      }

      return '' + id;
    }
  }, {
    key: 'updateSession',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(session, body) {
        var user;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!session.user) {
                  user = {};


                  if (body.message !== undefined) {
                    user = body.message.from;
                  } else if (body.callback_query !== undefined) {
                    user = body.callback_query.from;
                  }

                  session.user = (0, _extends3.default)({
                    platform: 'telegram'
                  }, user);
                }

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateSession(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return updateSession;
    }()
  }, {
    key: 'mapRequestToEvents',
    value: function mapRequestToEvents(body) {
      var rawEvent = this._getRawEventFromRequest(body);
      return [new _TelegramEvent2.default(rawEvent)];
    }
  }, {
    key: 'createContext',
    value: function createContext(_ref3) {
      var event = _ref3.event,
          session = _ref3.session;

      return new _TelegramContext2.default({
        client: this._client,
        event: event,
        session: session
      });
    }
  }, {
    key: 'platform',
    get: function get() {
      return 'telegram';
    }
  }, {
    key: 'client',
    get: function get() {
      return this._client;
    }
  }]);
  return TelegramConnector;
}(); /*
       eslint-disable class-methods-use-this
       
     */


exports.default = TelegramConnector;