'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _BasicHandlerBuilder2 = require('./BasicHandlerBuilder');

var _BasicHandlerBuilder3 = _interopRequireDefault(_BasicHandlerBuilder2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TelegramHandlerBuilder = function (_BasicHandlerBuilder) {
  (0, _inherits3.default)(TelegramHandlerBuilder, _BasicHandlerBuilder);

  function TelegramHandlerBuilder() {
    (0, _classCallCheck3.default)(this, TelegramHandlerBuilder);
    return (0, _possibleConstructorReturn3.default)(this, (TelegramHandlerBuilder.__proto__ || Object.getPrototypeOf(TelegramHandlerBuilder)).apply(this, arguments));
  }

  (0, _createClass3.default)(TelegramHandlerBuilder, [{
    key: 'onMessage',
    value: function onMessage(predicate, handler) {
      this.on(function (context) {
        return context.event.isMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onText',
    value: function onText(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onText\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.onMessage(function (context) {
          return context.event.isTextMessage && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.message.text);
        }, handler);
      } else {
        handler = arg1;

        this.onMessage(function (context) {
          return context.event.isTextMessage;
        }, handler);
      }

      return this;
    }
  }, {
    key: 'onCallbackQuery',
    value: function onCallbackQuery(arg1, arg2) {
      var pattern = void 0;
      var handler = void 0;
      if (arg2) {
        pattern = arg1;
        handler = arg2;

        (0, _warning2.default)(typeof pattern === 'string' || pattern instanceof RegExp, '\'onCallbackQuery\' only accepts string or regex, but received ' + (typeof pattern === 'undefined' ? 'undefined' : (0, _typeof3.default)(pattern)));

        this.on(function (context) {
          return context.event.isCallbackQuery && (0, _BasicHandlerBuilder2.matchPattern)(pattern, context.event.callbackQuery.data);
        }, handler);
      } else {
        handler = arg1;

        this.on(function (context) {
          return context.event.isCallbackQuery;
        }, handler);
      }

      return this;
    }
  }, {
    key: 'onPhoto',
    value: function onPhoto(predicate, handler) {
      this.on(function (context) {
        return context.event.isPhotoMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onDocument',
    value: function onDocument(predicate, handler) {
      this.on(function (context) {
        return context.event.isDocumentMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onAudio',
    value: function onAudio(predicate, handler) {
      this.on(function (context) {
        return context.event.isAudioMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onGame',
    value: function onGame(predicate, handler) {
      this.on(function (context) {
        return context.event.isGameMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onSticker',
    value: function onSticker(predicate, handler) {
      this.on(function (context) {
        return context.event.isStickerMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onVideo',
    value: function onVideo(predicate, handler) {
      this.on(function (context) {
        return context.event.isVideoMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onVoice',
    value: function onVoice(predicate, handler) {
      this.on(function (context) {
        return context.event.isVoiceMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onVideoNote',
    value: function onVideoNote(predicate, handler) {
      this.on(function (context) {
        return context.event.isVideoNoteMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onContact',
    value: function onContact(predicate, handler) {
      this.on(function (context) {
        return context.event.isContactMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onLocation',
    value: function onLocation(predicate, handler) {
      this.on(function (context) {
        return context.event.isLocationMessage && predicate(context);
      }, handler);
      return this;
    }
  }, {
    key: 'onVenue',
    value: function onVenue(predicate, handler) {
      this.on(function (context) {
        return context.event.isVenueMessage && predicate(context);
      }, handler);
      return this;
    }
  }]);
  return TelegramHandlerBuilder;
}(_BasicHandlerBuilder3.default);

exports.default = TelegramHandlerBuilder;