'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _ioredis = require('ioredis');

var _ioredis2 = _interopRequireDefault(_ioredis);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RedisCacheStore = function () {

  /*
    Support all of args supported by `ioredis`:
    - new Redis()       // Connect to 127.0.0.1:6379
    - new Redis(6380)   // 127.0.0.1:6380
    - new Redis(6379, '192.168.1.1')        // 192.168.1.1:6379
    - new Redis('/tmp/redis.sock')
    - new Redis({
        port: 6379,          // Redis port
        host: '127.0.0.1',   // Redis host
        family: 4,           // 4 (IPv4) or 6 (IPv6)
        password: 'auth',
        db: 0
      })
    // Connect to 127.0.0.1:6380, db 4, using password "authpassword"
    - new Redis('redis://:authpassword@127.0.0.1:6380/4')
  */
  function RedisCacheStore() {
    (0, _classCallCheck3.default)(this, RedisCacheStore);
    this._prefix = '';

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    this._redis = new (Function.prototype.bind.apply(_ioredis2.default, [null].concat((0, _toConsumableArray3.default)(args))))();
  }

  (0, _createClass3.default)(RedisCacheStore, [{
    key: 'get',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(key) {
        var val;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._redis.get('' + this._prefix + key);

              case 2:
                val = _context.sent;
                return _context.abrupt('return', this._unserialize(val));

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _ref.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'put',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(key, value, minutes) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._redis.setex('' + this._prefix + key, minutes * 60, this._serialize(value));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function put(_x2, _x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return put;
    }()
  }, {
    key: 'forget',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(key) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._redis.del('' + this._prefix + key);

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function forget(_x5) {
        return _ref3.apply(this, arguments);
      }

      return forget;
    }()
  }, {
    key: 'flush',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this._redis.flushdb();

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function flush() {
        return _ref4.apply(this, arguments);
      }

      return flush;
    }()
  }, {
    key: 'getRedis',
    value: function getRedis() {
      return this._redis;
    }
  }, {
    key: 'getPrefix',
    value: function getPrefix() {
      return this._prefix;
    }
  }, {
    key: 'setPrefix',
    value: function setPrefix(prefix) {
      this._prefix = prefix ? prefix + ':' : '';
    }
  }, {
    key: '_serialize',
    value: function _serialize(value) {
      return (0, _lodash.isNumber)(value) ? value : JSON.stringify(value);
    }
  }, {
    key: '_unserialize',
    value: function _unserialize(value) {
      return (0, _lodash.isNumber)(value) ? value : JSON.parse(value);
    }
  }]);
  return RedisCacheStore;
}();

exports.default = RedisCacheStore;