'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _messagingApiMessenger = require('messaging-api-messenger');

var _getConfig = require('../shared/getConfig');

var _getConfig2 = _interopRequireDefault(_getConfig);

var _log = require('../shared/log');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable consistent-return */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_domains, _configPath) {
    var platform, configPath, config, domains, client;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            platform = 'messenger';
            configPath = _configPath || 'bot.json';
            config = (0, _getConfig2.default)(configPath, platform);
            domains = _domains || config.domainWhitelist;


            (0, _invariant2.default)(config.accessToken, 'accessToken is not found in config file');
            (0, _invariant2.default)(domains, 'domains is required but not found. using -d <array of domain_name> separate by comma(,) to setup or list `domainWhitelist` key it in config file.');
            (0, _invariant2.default)(Array.isArray(domains), 'domains should be an array');
            (0, _invariant2.default)(domains.length < 10, 'The domains should less than 10');

            client = _messagingApiMessenger.MessengerClient.connect(config.accessToken);
            _context.next = 12;
            return client.setDomainWhitelist(domains);

          case 12:

            (0, _log.print)('successfully set whitelist to ' + (0, _log.bold)(domains));
            _context.next = 20;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context['catch'](0);

            (0, _log.error)('set whitelist error with');
            if (_context.t0.response) {
              (0, _log.error)('status: ' + (0, _log.bold)(_context.t0.response.status));
              if (_context.t0.response.data) {
                (0, _log.error)('data: ' + (0, _log.bold)(JSON.stringify(_context.t0.response.data, null, 2)));
              }
            } else {
              (0, _log.error)('message: ' + (0, _log.bold)(_context.t0.message));
            }
            return _context.abrupt('return', process.exit(1));

          case 20:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 15]]);
  }));

  function setDomainWhitelist(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return setDomainWhitelist;
}();