'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _messagingApiMessenger = require('messaging-api-messenger');

var _getConfig2 = require('../shared/getConfig');

var _getConfig3 = _interopRequireDefault(_getConfig2);

var _log = require('../shared/log');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_configPath) {
    var platform, configPath, _getConfig, accessToken, _getConfig$composerIn, composerInputDisabled, domainWhitelist, greetingText, persistentMenu, getStartedButtonPayload, valid, positive, negative, graphAPIClient;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            platform = 'messenger';
            configPath = _configPath || 'bot.json';
            _getConfig = (0, _getConfig3.default)(configPath, platform), accessToken = _getConfig.accessToken, _getConfig$composerIn = _getConfig.composerInputDisabled, composerInputDisabled = _getConfig$composerIn === undefined ? false : _getConfig$composerIn, domainWhitelist = _getConfig.domainWhitelist, greetingText = _getConfig.greetingText, persistentMenu = _getConfig.persistentMenu, getStartedButtonPayload = _getConfig.getStartedButtonPayload;
            valid = {
              composerInputDisabled: !!composerInputDisabled,
              domainWhitelist: !!domainWhitelist,
              greetingText: !!greetingText,
              persistentMenu: !!persistentMenu,
              getStartedButtonPayload: !!getStartedButtonPayload
            };
            positive = [];
            negative = [];


            Object.keys(valid).forEach(function (key) {
              return valid[key] ? positive.push('<' + (0, _log.bold)(key) + '>') : negative.push('<' + (0, _log.bold)(key) + '>');
            });

            if (positive.length > 0) {
              (0, _log.print)('We found ' + positive.join(', ') + ' in your config file and we are trying to setup this value.');
            }

            if (negative.length > 0) {
              (0, _log.print)('And we also support ' + negative.join(', ') + ' in config file.');
            }

            graphAPIClient = _messagingApiMessenger.MessengerClient.connect(accessToken);
            _context.next = 13;
            return graphAPIClient.deleteMessengerProfile(['persistent_menu', 'get_started']);

          case 13:
            _context.next = 15;
            return graphAPIClient.deleteMessengerProfile(['greeting']);

          case 15:
            if (!getStartedButtonPayload) {
              _context.next = 19;
              break;
            }

            _context.next = 18;
            return graphAPIClient.setGetStartedButton(getStartedButtonPayload);

          case 18:
            (0, _log.print)('Successfully set getStartedButton');

          case 19:
            if (!Array.isArray(persistentMenu)) {
              _context.next = 28;
              break;
            }

            if (!composerInputDisabled) {
              _context.next = 25;
              break;
            }

            _context.next = 23;
            return graphAPIClient.setPersistentMenu(persistentMenu, {
              composerInputDisabled: composerInputDisabled
            });

          case 23:
            _context.next = 27;
            break;

          case 25:
            _context.next = 27;
            return graphAPIClient.setPersistentMenu(persistentMenu);

          case 27:
            (0, _log.print)('Successfully set persistentMenu with composerInputDisabled: ' + composerInputDisabled);

          case 28:
            if (!greetingText) {
              _context.next = 32;
              break;
            }

            _context.next = 31;
            return graphAPIClient.setGreetingText(greetingText);

          case 31:
            (0, _log.print)('Successfully set greetingText');

          case 32:
            if (!domainWhitelist) {
              _context.next = 36;
              break;
            }

            _context.next = 35;
            return graphAPIClient.setDomainWhitelist(domainWhitelist);

          case 35:
            (0, _log.print)('Successfully set domain whitelist');

          case 36:
            _context.next = 43;
            break;

          case 38:
            _context.prev = 38;
            _context.t0 = _context['catch'](0);

            (0, _log.error)('set messenger profile error with');
            if (_context.t0.response) {
              (0, _log.error)('status: ' + (0, _log.bold)(_context.t0.response.status));
              if (_context.t0.response.data) {
                (0, _log.error)('data: ' + (0, _log.bold)(JSON.stringify(_context.t0.response.data, null, 2)));
              }
            } else {
              (0, _log.error)('message: ' + (0, _log.bold)(_context.t0.message));
            }
            return _context.abrupt('return', process.exit(1));

          case 43:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 38]]);
  }));

  function setMessengerProfile(_x) {
    return _ref.apply(this, arguments);
  }

  return setMessengerProfile;
}(); /* eslint-disable consistent-return */