'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _messagingApiMessenger = require('messaging-api-messenger');

var _getConfig2 = require('../shared/getConfig');

var _getConfig3 = _interopRequireDefault(_getConfig2);

var _log = require('../shared/log');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable consistent-return */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_configPath) {
    var platform, configPath, _getConfig, accessToken, persistentMenu, _getConfig$composerIn, composerInputDisabled, client;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            platform = 'messenger';
            configPath = _configPath || 'bot.json';
            _getConfig = (0, _getConfig3.default)(configPath, platform), accessToken = _getConfig.accessToken, persistentMenu = _getConfig.persistentMenu, _getConfig$composerIn = _getConfig.composerInputDisabled, composerInputDisabled = _getConfig$composerIn === undefined ? false : _getConfig$composerIn;


            (0, _invariant2.default)(accessToken, '`accessToken` is not found in config file.');
            (0, _invariant2.default)(persistentMenu, '`persistentMenu` is not found in config file.');

            client = _messagingApiMessenger.MessengerClient.connect(accessToken);
            _context.next = 9;
            return client.setPersistentMenu(persistentMenu, { composerInputDisabled: composerInputDisabled });

          case 9:

            (0, _log.print)('successfully set persistent menu to with composerInputDisabled: ' + composerInputDisabled);
            persistentMenu.forEach(function (item) {
              (0, _log.print)('- ' + item.title);
            });
            _context.next = 18;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context['catch'](0);

            (0, _log.error)('set persistent menu error with');
            if (_context.t0.response) {
              (0, _log.error)('status: ' + (0, _log.bold)(_context.t0.response.status));
              if (_context.t0.response.data) {
                (0, _log.error)('data: ' + (0, _log.bold)(JSON.stringify(_context.t0.response.data, null, 2)));
              }
            } else {
              (0, _log.error)('message: ' + (0, _log.bold)(_context.t0.message));
            }
            return _context.abrupt('return', process.exit(1));

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 13]]);
  }));

  function setPersistentMenu(_x) {
    return _ref.apply(this, arguments);
  }

  return setPersistentMenu;
}();