'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.localClient = exports.client = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _getConfig2 = require('../shared/getConfig');

var _getConfig3 = _interopRequireDefault(_getConfig2);

var _log = require('../shared/log');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var client = exports.client = _axios2.default.create({
  baseURL: 'https://api.telegram.org',
  headers: { 'Content-Type': 'application/json' }
});

var localClient = exports.localClient = _axios2.default.create({
  baseURL: 'http://localhost:4040'
});

var getWebhookFromNgrok = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var res;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return localClient.get('/api/tunnels');

          case 2:
            res = _context.sent;
            return _context.abrupt('return', (0, _get2.default)(res, 'data.tunnels[1].public_url'));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function getWebhookFromNgrok() {
    return _ref.apply(this, arguments);
  };
}();

exports.default = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_webhook, _configPath) {
    var platform, configPath, _getConfig, accessToken, webhook, res;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            platform = 'telegram';
            configPath = _configPath || 'bot.json';
            _getConfig = (0, _getConfig3.default)(configPath, platform), accessToken = _getConfig.accessToken;
            _context2.t0 = _webhook;

            if (_context2.t0) {
              _context2.next = 9;
              break;
            }

            _context2.next = 8;
            return getWebhookFromNgrok();

          case 8:
            _context2.t0 = _context2.sent;

          case 9:
            webhook = _context2.t0;


            (0, _invariant2.default)(accessToken, '`accessToken` is not found in config file');
            (0, _invariant2.default)(webhook, '`webhook` is required but not found. Use -w <webhook> to setup or make sure you are running ngrok server.');

            _context2.next = 14;
            return client.post('/bot' + accessToken + '/setWebhook');

          case 14:
            res = _context2.sent;

            (0, _invariant2.default)(res.data.success, 'Setting for webhook is failed');

            (0, _log.print)('Successfully set webhook');
            _context2.next = 24;
            break;

          case 19:
            _context2.prev = 19;
            _context2.t1 = _context2['catch'](0);

            (0, _log.error)('set webhook error with');
            if (_context2.t1.response) {
              (0, _log.error)('status: ' + (0, _log.bold)(_context2.t1.response.status));
              if (_context2.t1.response.data) {
                (0, _log.error)('data: ' + (0, _log.bold)(JSON.stringify(_context2.t1.response.data, null, 2)));
              }
            } else {
              (0, _log.error)('message: ' + (0, _log.bold)(_context2.t1.message));
            }
            return _context2.abrupt('return', process.exit(1));

          case 24:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 19]]);
  }));

  function setTelegramWebhook(_x, _x2) {
    return _ref2.apply(this, arguments);
  }

  return setTelegramWebhook;
}();