'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _shortid = require('shortid');

var _shortid2 = _interopRequireDefault(_shortid);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _isImage = require('is-image');

var _isImage2 = _interopRequireDefault(_isImage);

var _jsonfile = require('jsonfile');

var _jsonfile2 = _interopRequireDefault(_jsonfile);

var _hasha = require('hasha');

var _hasha2 = _interopRequireDefault(_hasha);

var _delay = require('delay');

var _delay2 = _interopRequireDefault(_delay);

var _fileType = require('file-type');

var _fileType2 = _interopRequireDefault(_fileType);

var _static = require('@yoctol/static');

var _log = require('../shared/log');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var folderPath = _ref2.folderPath,
        outputPath = _ref2.outputPath,
        _ref2$container = _ref2.container,
        container = _ref2$container === undefined ? 'cli-uploader' : _ref2$container,
        _ref2$staticManagerPa = _ref2.staticManagerPath,
        staticManagerPath = _ref2$staticManagerPa === undefined ? 'http://localhost:3000' : _ref2$staticManagerPa;
    var filenames, manager, pathOfMappingFile, i, uploadedImages, name, basename, imageMeta, checksum, file, data;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (_fs2.default.existsSync(folderPath)) {
              _context.next = 3;
              break;
            }

            (0, _log.error)('image folder path not found: ' + (0, _log.bold)(folderPath));
            return _context.abrupt('return', process.exit(1));

          case 3:
            (0, _log.print)('start to upload images in ' + (0, _log.bold)(folderPath));

            filenames = _glob2.default.sync(folderPath + '/*').filter(_isImage2.default);

            if (filenames.length) {
              _context.next = 8;
              break;
            }

            (0, _log.error)('No images found!');
            return _context.abrupt('return', process.exit(1));

          case 8:
            manager = new _static.StaticManager(staticManagerPath);


            (0, _log.print)('Your images:');
            (0, _log.print)(filenames.join('\n'));

            pathOfMappingFile = outputPath ? _path2.default.resolve(outputPath, 'uploaded-images.json') : _path2.default.resolve('uploaded-images.json');


            if (!_fs2.default.existsSync(pathOfMappingFile)) {
              _jsonfile2.default.writeFileSync(pathOfMappingFile, {});

              (0, _log.print)('initialize ' + (0, _log.bold)('uploaded-images.json') + ' for you');
            }

            i = 0;

          case 14:
            if (!(i < filenames.length)) {
              _context.next = 38;
              break;
            }

            uploadedImages = _jsonfile2.default.readFileSync(pathOfMappingFile);
            name = filenames[i];
            basename = _path2.default.basename(name);
            imageMeta = uploadedImages[basename];
            checksum = _hasha2.default.fromFileSync(name);

            if (!(!imageMeta || checksum !== imageMeta.checksum)) {
              _context.next = 35;
              break;
            }

            // overwrite
            file = _fs2.default.readFileSync(name);
            _context.prev = 22;
            _context.next = 25;
            return manager.pushFile(container, _shortid2.default.generate(), file, {
              contentType: (0, _fileType2.default)(file).mime
            });

          case 25:
            data = _context.sent;

            _jsonfile2.default.writeFileSync(pathOfMappingFile, (0, _extends4.default)({}, uploadedImages, (0, _defineProperty3.default)({}, basename, (0, _extends4.default)({}, data, {
              checksum: checksum
            }))), { spaces: 2 });
            (0, _log.print)(basename + ' is successfully uploaded');

            _context.next = 30;
            return (0, _delay2.default)(200);

          case 30:
            _context.next = 35;
            break;

          case 32:
            _context.prev = 32;
            _context.t0 = _context['catch'](22);

            (0, _log.error)(_context.t0);

          case 35:
            i++;
            _context.next = 14;
            break;

          case 38:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[22, 32]]);
  }));

  function uploadImages(_x) {
    return _ref.apply(this, arguments);
  }

  return uploadImages;
}(); /* eslint-disable no-await-in-loop, consistent-return */