'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _didyoumean = require('didyoumean');

var _didyoumean2 = _interopRequireDefault(_didyoumean);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _package = require('../../package.json');

var _package2 = _interopRequireDefault(_package);

var _log = require('./shared/log');

var _path = require('./shared/path');

var _init = require('./actions/init');

var _init2 = _interopRequireDefault(_init);

var _deleteDomainWhitelist = require('./actions/deleteDomainWhitelist');

var _deleteDomainWhitelist2 = _interopRequireDefault(_deleteDomainWhitelist);

var _deleteGetStartedButton = require('./actions/deleteGetStartedButton');

var _deleteGetStartedButton2 = _interopRequireDefault(_deleteGetStartedButton);

var _deleteGreetingText = require('./actions/deleteGreetingText');

var _deleteGreetingText2 = _interopRequireDefault(_deleteGreetingText);

var _deletePersistentMenu = require('./actions/deletePersistentMenu');

var _deletePersistentMenu2 = _interopRequireDefault(_deletePersistentMenu);

var _getDomainWhitelist = require('./actions/getDomainWhitelist');

var _getDomainWhitelist2 = _interopRequireDefault(_getDomainWhitelist);

var _getGetStartedButton = require('./actions/getGetStartedButton');

var _getGetStartedButton2 = _interopRequireDefault(_getGetStartedButton);

var _getGreetingText = require('./actions/getGreetingText');

var _getGreetingText2 = _interopRequireDefault(_getGreetingText);

var _getPersistentMenu = require('./actions/getPersistentMenu');

var _getPersistentMenu2 = _interopRequireDefault(_getPersistentMenu);

var _setDomainWhitelist = require('./actions/setDomainWhitelist');

var _setDomainWhitelist2 = _interopRequireDefault(_setDomainWhitelist);

var _setGetStartedButton = require('./actions/setGetStartedButton');

var _setGetStartedButton2 = _interopRequireDefault(_setGetStartedButton);

var _setGreetingText = require('./actions/setGreetingText');

var _setGreetingText2 = _interopRequireDefault(_setGreetingText);

var _setMessengerProfile = require('./actions/setMessengerProfile');

var _setMessengerProfile2 = _interopRequireDefault(_setMessengerProfile);

var _setPersistentMenu = require('./actions/setPersistentMenu');

var _setPersistentMenu2 = _interopRequireDefault(_setPersistentMenu);

var _setWebhook = require('./actions/setWebhook');

var _setWebhook2 = _interopRequireDefault(_setWebhook);

var _setTelegramWebhook = require('./actions/setTelegramWebhook');

var _setTelegramWebhook2 = _interopRequireDefault(_setTelegramWebhook);

var _uploadImages = require('./actions/uploadImages');

var _uploadImages2 = _interopRequireDefault(_uploadImages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.version(_package2.default.version);

_commander2.default.command('init').description('initialize your bot').action(function () {
  (0, _init2.default)();
});

_commander2.default.command('domain-whitelist:get').alias('dwg').description('get domain whitelist').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref) {
  var config = _ref.config;

  (0, _getDomainWhitelist2.default)(config);
});

_commander2.default.command('domain-whitelist:set').alias('dws').description('set domains whitelist').option('-d, --domains <array of domain_name>', 'All domains to set domains whitelist, should separate by comma(,)').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref2) {
  var config = _ref2.config,
      domains = _ref2.domains;

  (0, _invariant2.default)(domains, '-d <array of domain_name> is required but not found.');
  (0, _setDomainWhitelist2.default)(domains.split(','), config);
});

_commander2.default.command('domain-whitelist:delete').alias('dwd').description('delete domain whitelist').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref3) {
  var config = _ref3.config;

  (0, _deleteDomainWhitelist2.default)(config);
});

_commander2.default.command('persistent-menu:get').alias('pmg').description('get persistent menu').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref4) {
  var config = _ref4.config;

  (0, _getPersistentMenu2.default)(config);
});

_commander2.default.command('persistent-menu:set').alias('pms').description('set persistent menu').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref5) {
  var config = _ref5.config;

  (0, _setPersistentMenu2.default)(config);
});

_commander2.default.command('persistent-menu:delete').alias('pmd').description('delete persistent menu').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref6) {
  var config = _ref6.config;

  (0, _deletePersistentMenu2.default)(config);
});

_commander2.default.command('get-started:get').alias('gsg').description('get get started button').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref7) {
  var config = _ref7.config;

  (0, _getGetStartedButton2.default)(config);
});

_commander2.default.command('get-started:set').alias('gss').description('set get started button').option('-p, --payload <payload>', 'The payload to set for get started button').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref8) {
  var payload = _ref8.payload,
      config = _ref8.config;

  (0, _setGetStartedButton2.default)(payload, config);
});

_commander2.default.command('get-started:delete').alias('gsd').description('delete get started button').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref9) {
  var config = _ref9.config;

  (0, _deleteGetStartedButton2.default)(config);
});

_commander2.default.command('greeting-text:get').alias('gtg').description('get greeting text').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref10) {
  var config = _ref10.config;

  (0, _getGreetingText2.default)(config);
});

_commander2.default.command('greeting-text:set').alias('gts').description('set greeting text for specific project').option('-g, --greetingText <greeting_text>', 'The greeting text of the bot').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref11) {
  var config = _ref11.config,
      greetingText = _ref11.greetingText;

  (0, _invariant2.default)(greetingText, '-g <greeting_text> is required but not found.');
  (0, _setGreetingText2.default)(greetingText, config);
});

_commander2.default.command('greeting-text:delete').alias('gtd').description('delete greeting text').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref12) {
  var config = _ref12.config;

  (0, _deleteGreetingText2.default)(config);
});

_commander2.default.command('messenger-profile:set').alias('mps').description('set messenger profile from config file').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref13) {
  var config = _ref13.config;

  (0, _setMessengerProfile2.default)(config);
});

_commander2.default.command('set-webhook').alias('swh').description('set messenger webhook url').option('-w, --webhook <webhook_url>', 'The callback url for webhook.').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').option('-v, --verifyToken <verify_token>', 'The verify token for webhook usage.').action(function (_ref14) {
  var webhook = _ref14.webhook,
      config = _ref14.config,
      verifyToken = _ref14.verifyToken;

  (0, _setWebhook2.default)(webhook, config, verifyToken);
});

_commander2.default.command('set-telegram-webhook').alias('stwh').description('set telegram webhook url').option('-w, --webhook <webhook_url>', 'The callback url for webhook.').option('-c, --config <config_file_path>', 'The config file path of your project. Default to `bot.json`').action(function (_ref15) {
  var webhook = _ref15.webhook,
      config = _ref15.config;

  (0, _setTelegramWebhook2.default)(webhook, config);
});

_commander2.default.command('upload-images <folder>').alias('img').description('upload all images in the folder').option('-o, --output <output_path>', 'The out path of the upload result json file.').option('-c, --container <container_name>', 'The URL prefix of the file').action(function (folderPath, _ref16) {
  var output = _ref16.output,
      container = _ref16.container;

  (0, _uploadImages2.default)({
    folderPath: (0, _path.toAbsolutePath)(folderPath),
    outputPath: output,
    container: container
  });
});

_commander2.default.command('*').action(function (command) {
  (0, _log.error)('unknown command: ' + (0, _log.bold)(command));
  var commandNames = _commander2.default.commands.map(function (c) {
    return c._name;
  }).filter(function (name) {
    return name !== '*';
  });

  var closeMatch = (0, _didyoumean2.default)(command, commandNames);
  if (closeMatch) {
    (0, _log.error)('did you mean ' + (0, _log.bold)(closeMatch) + '?');
  }
  process.exit(1);
});

_commander2.default.parse(process.argv);