'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _delay = require('delay');

var _delay2 = _interopRequireDefault(_delay);

require('./Context');

var _ConsoleEvent = require('./ConsoleEvent');

var _ConsoleEvent2 = _interopRequireDefault(_ConsoleEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ConsoleContext = function () {
  function ConsoleContext(_ref) {
    var client = _ref.client,
        event = _ref.event,
        session = _ref.session;
    (0, _classCallCheck3.default)(this, ConsoleContext);
    this._messageDelay = 0;

    this._client = client;
    this._event = event;
    this._session = session;
  }

  /**
   * The name of the platform.
   *
   */


  (0, _createClass3.default)(ConsoleContext, [{
    key: 'setMessageDelay',


    /**
     * Set delay before sending every messages.
     *
     */
    value: function setMessageDelay(milliseconds) {
      this._messageDelay = milliseconds;
    }

    /**
     * Delay and show indicators for milliseconds.
     *
     */

  }, {
    key: 'typing',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(milliseconds) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _delay2.default)(milliseconds);

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function typing(_x) {
        return _ref2.apply(this, arguments);
      }

      return typing;
    }()

    /**
     * Send text to the owner of then session.
     *
     */

  }, {
    key: 'sendText',
    value: function sendText(text) {
      var _this = this;

      setTimeout(function () {
        _this._client.sendText(text);
      }, this._messageDelay);
    }
  }, {
    key: 'sendTextWithDelay',
    value: function sendTextWithDelay(delay, text) {
      var _this2 = this;

      setTimeout(function () {
        _this2._client.sendText(text);
      }, delay);
    }
  }, {
    key: 'platform',
    get: function get() {
      return 'console';
    }

    /**
     * The client instance.
     *
     */

  }, {
    key: 'client',
    get: function get() {
      return this._client;
    }

    /**
     * The event instance.
     *
     */

  }, {
    key: 'event',
    get: function get() {
      return this._event;
    }

    /**
     * The session state of the context.
     *
     */

  }, {
    key: 'session',
    get: function get() {
      return this._session;
    }
  }]);
  return ConsoleContext;
}();

exports.default = ConsoleContext;