'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DelayableJobQueue = function () {
  function DelayableJobQueue() {
    (0, _classCallCheck3.default)(this, DelayableJobQueue);

    this._queue = [];
    this._processing = false;
  }

  (0, _createClass3.default)(DelayableJobQueue, [{
    key: 'beforeEach',
    value: function beforeEach(fn) {
      this._beforeEach = fn;
      return this;
    }
  }, {
    key: 'afterEach',
    value: function afterEach(fn) {
      this._afterEach = fn;
      return this;
    }
  }, {
    key: 'before',
    value: function before(fn) {
      this._before = fn;
      return this;
    }
  }, {
    key: 'after',
    value: function after(fn) {
      this._after = fn;
      return this;
    }
  }, {
    key: 'enqueue',
    value: function enqueue(item) {
      this._queue.push(item);
      if (!this._processing) {
        this._process();
      }
    }
  }, {
    key: '_dequeue',
    value: function _dequeue() {
      return this._queue.shift();
    }
  }, {
    key: '_process',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var item, _instance, _method, _args, _onSuccess, _onError, response;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;

                this._processing = true;
                this._beforeProcessing = true;
                /* eslint-disable no-await-in-loop */

              case 3:
                if (!this._hasItem) {
                  _context.next = 38;
                  break;
                }

                item = this._dequeue();
                _instance = item.instance, _method = item.method, _args = item.args, _onSuccess = item.onSuccess, _onError = item.onError;

                if (!this._beforeProcessing) {
                  _context.next = 11;
                  break;
                }

                if (!(typeof this._before === 'function')) {
                  _context.next = 10;
                  break;
                }

                _context.next = 10;
                return this._before(item);

              case 10:
                this._beforeProcessing = false;

              case 11:
                if (!(typeof this._beforeEach === 'function')) {
                  _context.next = 14;
                  break;
                }

                _context.next = 14;
                return this._beforeEach(item);

              case 14:
                _context.prev = 14;
                _context.next = 17;
                return _instance[_method].apply(_instance, (0, _toConsumableArray3.default)(_args));

              case 17:
                response = _context.sent;

                if (_onSuccess) {
                  _onSuccess(response);
                }
                _context.next = 29;
                break;

              case 21:
                _context.prev = 21;
                _context.t0 = _context['catch'](14);

                if (!_onError) {
                  _context.next = 27;
                  break;
                }

                _onError(_context.t0);
                _context.next = 29;
                break;

              case 27:
                console.error(_context.t0);
                throw _context.t0;

              case 29:
                if (!(typeof this._afterEach === 'function')) {
                  _context.next = 32;
                  break;
                }

                _context.next = 32;
                return this._afterEach(item);

              case 32:
                if (this._hasItem) {
                  _context.next = 36;
                  break;
                }

                if (!(typeof this._after === 'function')) {
                  _context.next = 36;
                  break;
                }

                _context.next = 36;
                return this._after(item);

              case 36:
                _context.next = 3;
                break;

              case 38:
                this._processing = false;
                /* eslint-enable no-await-in-loop */
                _context.next = 44;
                break;

              case 41:
                _context.prev = 41;
                _context.t1 = _context['catch'](0);

                console.error(_context.t1);

              case 44:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 41], [14, 21]]);
      }));

      function _process() {
        return _ref.apply(this, arguments);
      }

      return _process;
    }()
  }, {
    key: '_hasItem',
    get: function get() {
      return !!this._queue.length;
    }
  }]);
  return DelayableJobQueue;
}();

exports.default = DelayableJobQueue;