'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TelegramEvent = function () {
  function TelegramEvent(rawEvent) {
    (0, _classCallCheck3.default)(this, TelegramEvent);

    this._rawEvent = rawEvent;
  }

  /**
   * Underlying raw event from Telegram.
   *
   */


  (0, _createClass3.default)(TelegramEvent, [{
    key: 'rawEvent',
    get: function get() {
      return this._rawEvent;
    }

    /**
     * Determine if the event is a message event.
     *
     */

  }, {
    key: 'isMessage',
    get: function get() {
      return !!this._rawEvent.message;
    }

    /**
     * The message object from Telegram raw event.
     *
     */

  }, {
    key: 'message',
    get: function get() {
      return this._rawEvent.message;
    }
  }, {
    key: 'callbackQuery',
    get: function get() {
      return this._rawEvent.callback_query;
    }

    /**
     * Determine if the event is a message event which includes text.
     *
     */

  }, {
    key: 'isTextMessage',
    get: function get() {
      return this.isMessage && typeof this.message.text === 'string';
    }

    /**
     * Determine if the event is a message event which includes audio.
     *
     */

  }, {
    key: 'isAudioMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.audio && (0, _typeof3.default)(message.audio) === 'object';
    }

    /**
     * Determine if the event is a message event which includes document.
     *
     */

  }, {
    key: 'isDocumentMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.document && (0, _typeof3.default)(message.document) === 'object';
    }

    /**
     * Determine if the event is a message event which includes game.
     *
     */

  }, {
    key: 'isGameMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.game && (0, _typeof3.default)(message.game) === 'object';
    }

    /**
     * Determine if the event is a message event which includes photo.
     *
     */

  }, {
    key: 'isPhotoMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.photo && message.photo.length > 0;
    }

    /**
     * Determine if the event is a message event which includes sticker.
     *
     */

  }, {
    key: 'isStickerMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.sticker && (0, _typeof3.default)(message.sticker) === 'object';
    }

    /**
     * Determine if the event is a message event which includes video.
     *
     */

  }, {
    key: 'isVideoMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;
      return !!message.video && (0, _typeof3.default)(message.video) === 'object';
    }

    /**
     * Determine if the event is a message event which includes voice.
     *
     */

  }, {
    key: 'isVoiceMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.voice && (0, _typeof3.default)(message.voice) === 'object';
    }

    /**
     * Determine if the event is a message event which includes video note.
     *
     */

  }, {
    key: 'isVideoNoteMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.video_note && (0, _typeof3.default)(message.video_note) === 'object';
    }

    /**
     * Determine if the event is a message event which includes contact.
     *
     */

  }, {
    key: 'isContactMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.contact && (0, _typeof3.default)(message.contact) === 'object';
    }

    /**
     * Determine if the event is a message event which includes location.
     *
     */

  }, {
    key: 'isLocationMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.location && (0, _typeof3.default)(message.location) === 'object';
    }

    /**
     * Determine if the event is a message event which includes venue.
     *
     */

  }, {
    key: 'isVenueMessage',
    get: function get() {
      if (!this.isMessage) return false;

      var message = this.message;

      return !!message.venue && (0, _typeof3.default)(message.venue) === 'object';
    }

    /**
     * Determine if the event is a callback query event.
     *
     */

  }, {
    key: 'isCallbackQuery',
    get: function get() {
      return !!this.callbackQuery && (0, _typeof3.default)(this.callbackQuery) === 'object';
    }
  }]);
  return TelegramEvent;
}();

exports.default = TelegramEvent;