'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var verifyLINESignature = function verifyLINESignature(bot) {
  return function (_ref, next) {
    var request = _ref.request,
        response = _ref.response;

    if (bot.connector.verifySignature(request.rawBody, request.header['x-line-signature'])) {
      return next();
    }
    var error = {
      message: 'LINE Signature Validation Failed!',
      request: {
        rawBody: request.rawBody,
        header: {
          'x-line-signature': request.header['x-line-signature']
        }
      }
    };
    console.error(error);
    response.status = 400;
    response.body = { error: error };
  };
};

exports.default = verifyLINESignature;