'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _micro = require('micro');

var _verifyLINESignature = require('./verifyLINESignature');

var _verifyLINESignature2 = _interopRequireDefault(_verifyLINESignature);

var _verifyMessengerWebhook = require('./verifyMessengerWebhook');

var _verifyMessengerWebhook2 = _interopRequireDefault(_verifyMessengerWebhook);

var _verifySlackWebhook = require('./verifySlackWebhook');

var _verifySlackWebhook2 = _interopRequireDefault(_verifySlackWebhook);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createRequestHandler(bot) {
  var _this = this;

  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var requestHandler = bot.createRequestHandler();
  return function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(req, res) {
      var body, LINEVerified;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(req.method === 'GET' && bot.connector.platform === 'messenger')) {
                _context.next = 4;
                break;
              }

              (0, _verifyMessengerWebhook2.default)({ verifyToken: config.verifyToken })(req, res);
              _context.next = 25;
              break;

            case 4:
              if (!(req.method === 'POST')) {
                _context.next = 24;
                break;
              }

              _context.next = 7;
              return (0, _micro.json)(req);

            case 7:
              body = _context.sent;

              if (!(bot.connector.platform === 'slack' && body.type === 'url_verification')) {
                _context.next = 13;
                break;
              }

              _context.next = 11;
              return (0, _verifySlackWebhook2.default)()(req, res);

            case 11:
              _context.next = 22;
              break;

            case 13:
              if (!(bot.connector.platform === 'line')) {
                _context.next = 19;
                break;
              }

              _context.next = 16;
              return (0, _verifyLINESignature2.default)(bot)(req, res);

            case 16:
              LINEVerified = _context.sent;

              if (LINEVerified) {
                _context.next = 19;
                break;
              }

              return _context.abrupt('return');

            case 19:
              _context.next = 21;
              return requestHandler(body);

            case 21:
              (0, _micro.send)(res, 200);

            case 22:
              _context.next = 25;
              break;

            case 24:
              (0, _micro.send)(res, 405);

            case 25:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function (_x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
}

exports.default = createRequestHandler;