'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _micro = require('micro');

var _micro2 = _interopRequireDefault(_micro);

var _shortid = require('shortid');

var _shortid2 = _interopRequireDefault(_shortid);

var _connectNgrok = require('../connectNgrok');

var _connectNgrok2 = _interopRequireDefault(_connectNgrok);

var _createRequestHandler = require('./createRequestHandler');

var _createRequestHandler2 = _interopRequireDefault(_createRequestHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createServer(bot) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  config.verifyToken = config.verifyToken || _shortid2.default.generate();

  var server = (0, _micro2.default)((0, _createRequestHandler2.default)(bot, config));

  var _listen = server.listen.bind(server);
  server.listen = function () {
    _listen.apply(undefined, arguments);
    if (config.ngrok) {
      (0, _connectNgrok2.default)(arguments.length <= 0 ? undefined : arguments[0], function (err, url) {
        console.log('webhook url: ' + url + '/');
      });
    }
    if (bot.connector.platform === 'messenger') {
      console.log('verify token: ' + config.verifyToken);
    }
  };

  return server;
}

exports.default = createServer;