'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _micro = require('micro');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var verifyLINESignature = function verifyLINESignature(bot) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(req, res) {
      var rawBody, verified;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _micro.text)(req);

            case 2:
              rawBody = _context.sent;
              verified = bot.connector.verifySignature(rawBody, req.headers['x-line-signature']);


              if (!verified) {
                (0, _micro.send)(res, 400, {
                  error: {
                    message: 'LINE Signature Validation Failed!',
                    request: {
                      rawBody: rawBody,
                      headers: {
                        'x-line-signature': req.headers['x-line-signature']
                      }
                    }
                  }
                });
              }
              return _context.abrupt('return', verified);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

exports.default = verifyLINESignature;