'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _micro = require('micro');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var verifyMessengerWebhook = function verifyMessengerWebhook(_ref) {
  var verifyToken = _ref.verifyToken;
  return function (req, res) {
    var _url$parse = _url2.default.parse(req.url, true),
        query = _url$parse.query;

    if (query['hub.mode'] === 'subscribe' && query['hub.verify_token'] === verifyToken) {
      (0, _micro.send)(res, 200, query['hub.challenge']);
    } else {
      console.error('Failed validation. Make sure the validation tokens match.');
      (0, _micro.send)(res, 403);
    }
  };
};

exports.default = verifyMessengerWebhook;