'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _jfs = require('jfs');

var _jfs2 = _interopRequireDefault(_jfs);

var _thenify = require('thenify');

var _thenify2 = _interopRequireDefault(_thenify);

var _is_before = require('date-fns/is_before');

var _is_before2 = _interopRequireDefault(_is_before);

var _sub_minutes = require('date-fns/sub_minutes');

var _sub_minutes2 = _interopRequireDefault(_sub_minutes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MINUTES_IN_ONE_YEAR = 365 * 24 * 60;

var FileSessionStore = function () {
  function FileSessionStore(dirname, expiresIn) {
    (0, _classCallCheck3.default)(this, FileSessionStore);

    this._expiresIn = expiresIn || MINUTES_IN_ONE_YEAR;
    var jfs = new _jfs2.default(dirname || '.sessions');
    jfs.get = (0, _thenify2.default)(jfs.get);
    jfs.save = (0, _thenify2.default)(jfs.save);
    jfs.delete = (0, _thenify2.default)(jfs.delete);
    this._jfs = jfs;
  }

  // The number of minutes to store the data in the session.


  (0, _createClass3.default)(FileSessionStore, [{
    key: 'init',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this);

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _ref.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(key) {
        var session;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this._jfs.get(key).catch(function () {
                  return null;
                });

              case 2:
                session = _context2.sent;

                if (!(session && this._expired(session))) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt('return', null);

              case 5:
                return _context2.abrupt('return', session);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: 'write',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(key, sess) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this._jfs.save(key, sess);

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function write(_x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'destroy',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(key) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this._jfs.delete(key));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function destroy(_x4) {
        return _ref4.apply(this, arguments);
      }

      return destroy;
    }()
  }, {
    key: 'getJFS',
    value: function getJFS() {
      return this._jfs;
    }
  }, {
    key: '_expired',
    value: function _expired(sess) {
      return sess.lastActivity !== undefined && (0, _is_before2.default)(sess.lastActivity, (0, _sub_minutes2.default)(Date.now(), this._expiresIn));
    }
  }]);
  return FileSessionStore;
}();

exports.default = FileSessionStore;