'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _mongodb = require('mongodb');

var _is_before = require('date-fns/is_before');

var _is_before2 = _interopRequireDefault(_is_before);

var _sub_minutes = require('date-fns/sub_minutes');

var _sub_minutes2 = _interopRequireDefault(_sub_minutes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MINUTES_IN_ONE_YEAR = 365 * 24 * 60;

var MongoSessionStore = function () {

  // The number of minutes to store the data in the session.
  function MongoSessionStore(url) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var expiresIn = arguments[2];
    (0, _classCallCheck3.default)(this, MongoSessionStore);

    this._url = url;
    this._collectionName = options.collectionName || 'sessions';
    this._expiresIn = expiresIn || MINUTES_IN_ONE_YEAR;
  }

  (0, _createClass3.default)(MongoSessionStore, [{
    key: 'init',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _mongodb.MongoClient.connect(this._url);

              case 2:
                this._connection = _context.sent;
                return _context.abrupt('return', this);

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init() {
        return _ref.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(key) {
        var _key$split, _key$split2, platform, id, filter, session;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // FIXME: remove later
                _key$split = key.split(':'), _key$split2 = (0, _slicedToArray3.default)(_key$split, 2), platform = _key$split2[0], id = _key$split2[1];
                filter = {
                  $or: [{ id: key }, {
                    'user.platform': platform,
                    'user.id': id
                  }]
                };
                _context2.next = 4;
                return this._sessions.findOne(filter);

              case 4:
                session = _context2.sent;

                if (!(session && this._expired(session))) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt('return', null);

              case 7:
                return _context2.abrupt('return', session);

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x2) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()
  }, {
    key: 'write',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(key, sess) {
        var _key$split3, _key$split4, platform, id, filter;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                // FIXME: remove later
                _key$split3 = key.split(':'), _key$split4 = (0, _slicedToArray3.default)(_key$split3, 2), platform = _key$split4[0], id = _key$split4[1];
                filter = {
                  $or: [{ id: key }, {
                    'user.platform': platform,
                    'user.id': id
                  }]
                };
                _context3.next = 4;
                return this._sessions.updateOne(filter, sess, {
                  upsert: true
                });

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function write(_x3, _x4) {
        return _ref3.apply(this, arguments);
      }

      return write;
    }()
  }, {
    key: 'destroy',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(key) {
        var _key$split5, _key$split6, platform, id, filter;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                // FIXME: remove later
                _key$split5 = key.split(':'), _key$split6 = (0, _slicedToArray3.default)(_key$split5, 2), platform = _key$split6[0], id = _key$split6[1];
                filter = {
                  $or: [{ id: key }, {
                    'user.platform': platform,
                    'user.id': id
                  }]
                };
                _context4.next = 4;
                return this._sessions.remove(filter);

              case 4:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function destroy(_x5) {
        return _ref4.apply(this, arguments);
      }

      return destroy;
    }()
  }, {
    key: '_expired',
    value: function _expired(sess) {
      return sess.lastActivity !== undefined && (0, _is_before2.default)(sess.lastActivity, (0, _sub_minutes2.default)(Date.now(), this._expiresIn));
    }
  }, {
    key: '_sessions',
    get: function get() {
      if (this._connection == null) {
        throw new Error('MongoSessionStore: must call `init` before any operation.');
      }
      return this._connection.collection(this._collectionName);
    }
  }]);
  return MongoSessionStore;
}();

exports.default = MongoSessionStore;